
/**
 * Demonstrace algoritmu BubbleSort.
 */
public class BubbleSort {

    /**
     * Pole, které se řadí.
     */
    private IntArray array;

    /**
     * Vytvoří novou instanci třídy BubbleSort.
     *
     * @param array
     *            pole, které se bude řadit.
     */
    public BubbleSort(IntArray array) {
        this.array = array;
    }

    /**
     * Seřadí vzestupně pole pomocí algoritmu BubbleSort.
     */
    public void sort() {
        
        for (int i = 0; i < array.size(); i++) {
            boolean swaped = false;
            for(int j = 0; j < array.size()-i-1;j++) {
                if(array.get(j) > array.get(j+1)) {
                    array.swap(j, j+1);
                    swaped = true;
                }
            }
            printPass(i);
            if(!swaped) break;
        }
    }

    /**
     * Pomocná metoda pro tisk jednoho průchodu algoritmu.
     *
     * @param pass
     *            číslo průchodu.
     */
    private void printPass(int pass) {
        System.out.printf("po průchodu %3d: ", pass);
        System.out.println(array);
    }
}
